> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.ordergroove.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.ordergroove.com/_mcp/server.

# Update Components

POST https://restapi.ordergroove.com/subscriptions/{subscription_public_Id}/components/bulk_operation/
Content-Type: application/json

Atomically modify (create, update, and/or delete) components associated with a subscription

Reference: https://docs.ordergroove.com/reference/rest-rpc-api/components/update-components

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: ordergroove-restrpc
  version: 1.0.0
paths:
  /subscriptions/{subscription_public_Id}/components/bulk_operation/:
    post:
      operationId: update-components
      summary: Update Components
      description: >-
        Atomically modify (create, update, and/or delete) components associated
        with a subscription
      tags:
        - components
      parameters:
        - name: subscription_public_Id
          in: path
          description: Unique subscription ID
          required: true
          schema:
            type: string
        - name: x-api-key
          in: header
          required: true
          schema:
            type: string
      responses:
        '200':
          description: '200'
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Components_update-components_Response_200'
        '400':
          description: '400'
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Update-componentsRequestBadRequestError'
      requestBody:
        content:
          application/json:
            schema:
              type: object
              properties:
                create:
                  type: array
                  items:
                    $ref: >-
                      #/components/schemas/SubscriptionsSubscriptionPublicIdComponentsBulkOperationPostRequestBodyContentApplicationJsonSchemaCreateItems
                  description: Bundle Components to create with product and its quantity
                update:
                  type: array
                  items:
                    $ref: >-
                      #/components/schemas/SubscriptionsSubscriptionPublicIdComponentsBulkOperationPostRequestBodyContentApplicationJsonSchemaUpdateItems
                  description: Bundle Components to be updated with fields to change
                delete:
                  type: array
                  items:
                    type: string
                  description: >-
                    Bundle components public ids to be deleted
                    ["85eae83c245111eeb185acde48001122","b3928a0c3c4211eeac2bacde48001122"]
servers:
  - url: https://restapi.ordergroove.com
    description: https://restapi.ordergroove.com
components:
  schemas:
    SubscriptionsSubscriptionPublicIdComponentsBulkOperationPostRequestBodyContentApplicationJsonSchemaCreateItems:
      type: object
      properties:
        product:
          type: string
          description: The id of the product that is being added to the bundle
        quantity:
          type: integer
          default: 1
          description: The quantity of the product being added
      required:
        - product
        - quantity
      title: >-
        SubscriptionsSubscriptionPublicIdComponentsBulkOperationPostRequestBodyContentApplicationJsonSchemaCreateItems
    SubscriptionsSubscriptionPublicIdComponentsBulkOperationPostRequestBodyContentApplicationJsonSchemaUpdateItems:
      type: object
      properties:
        public_id:
          type: string
          description: The id of the component to be modified
        quantity:
          type: integer
          description: The new quantity to set for the component
        product:
          type: string
          description: The new product to set for the component
      required:
        - public_id
      title: >-
        SubscriptionsSubscriptionPublicIdComponentsBulkOperationPostRequestBodyContentApplicationJsonSchemaUpdateItems
    SubscriptionsSubscriptionPublicIdComponentsBulkOperationPostResponsesContentApplicationJsonSchemaCreatedItems:
      type: object
      properties:
        public_id:
          type: string
        product:
          type: string
        quantity:
          type: integer
          default: 0
      title: >-
        SubscriptionsSubscriptionPublicIdComponentsBulkOperationPostResponsesContentApplicationJsonSchemaCreatedItems
    SubscriptionsSubscriptionPublicIdComponentsBulkOperationPostResponsesContentApplicationJsonSchemaUpdatedItems:
      type: object
      properties:
        public_id:
          type: string
        product:
          type: string
        quantity:
          type: integer
          default: 0
      title: >-
        SubscriptionsSubscriptionPublicIdComponentsBulkOperationPostResponsesContentApplicationJsonSchemaUpdatedItems
    SubscriptionsSubscriptionPublicIdComponentsBulkOperationPostResponsesContentApplicationJsonSchemaDeletedItems:
      type: object
      properties:
        public_id:
          type: string
        product:
          type: string
        quantity:
          type: integer
          default: 0
      title: >-
        SubscriptionsSubscriptionPublicIdComponentsBulkOperationPostResponsesContentApplicationJsonSchemaDeletedItems
    Components_update-components_Response_200:
      type: object
      properties:
        created:
          type: array
          items:
            $ref: >-
              #/components/schemas/SubscriptionsSubscriptionPublicIdComponentsBulkOperationPostResponsesContentApplicationJsonSchemaCreatedItems
        updated:
          type: array
          items:
            $ref: >-
              #/components/schemas/SubscriptionsSubscriptionPublicIdComponentsBulkOperationPostResponsesContentApplicationJsonSchemaUpdatedItems
        deleted:
          type: array
          items:
            $ref: >-
              #/components/schemas/SubscriptionsSubscriptionPublicIdComponentsBulkOperationPostResponsesContentApplicationJsonSchemaDeletedItems
      title: Components_update-components_Response_200
    Update-componentsRequestBadRequestError:
      type: object
      properties: {}
      title: Update-componentsRequestBadRequestError
  securitySchemes:
    x-api-key:
      type: apiKey
      in: header
      name: x-api-key

```

## Examples



**Request**

```json
{}
```

**Response**

```json
{}
```

**SDK Code**

```python Result
import requests

url = "https://restapi.ordergroove.com/subscriptions/subscription_public_Id/components/bulk_operation/"

payload = {}
headers = {
    "x-api-key": "<apiKey>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript Result
const url = 'https://restapi.ordergroove.com/subscriptions/subscription_public_Id/components/bulk_operation/';
const options = {
  method: 'POST',
  headers: {'x-api-key': '<apiKey>', 'Content-Type': 'application/json'},
  body: '{}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Result
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://restapi.ordergroove.com/subscriptions/subscription_public_Id/components/bulk_operation/"

	payload := strings.NewReader("{}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("x-api-key", "<apiKey>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Result
require 'uri'
require 'net/http'

url = URI("https://restapi.ordergroove.com/subscriptions/subscription_public_Id/components/bulk_operation/")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["x-api-key"] = '<apiKey>'
request["Content-Type"] = 'application/json'
request.body = "{}"

response = http.request(request)
puts response.read_body
```

```java Result
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://restapi.ordergroove.com/subscriptions/subscription_public_Id/components/bulk_operation/")
  .header("x-api-key", "<apiKey>")
  .header("Content-Type", "application/json")
  .body("{}")
  .asString();
```

```php Result
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://restapi.ordergroove.com/subscriptions/subscription_public_Id/components/bulk_operation/', [
  'body' => '{}',
  'headers' => [
    'Content-Type' => 'application/json',
    'x-api-key' => '<apiKey>',
  ],
]);

echo $response->getBody();
```

```csharp Result
using RestSharp;

var client = new RestClient("https://restapi.ordergroove.com/subscriptions/subscription_public_Id/components/bulk_operation/");
var request = new RestRequest(Method.POST);
request.AddHeader("x-api-key", "<apiKey>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift Result
import Foundation

let headers = [
  "x-api-key": "<apiKey>",
  "Content-Type": "application/json"
]
let parameters = [] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://restapi.ordergroove.com/subscriptions/subscription_public_Id/components/bulk_operation/")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```